package com.engine.organization.entity.extend.bo;

import com.engine.organization.entity.extend.po.ExtendGroupPO;
import com.engine.organization.entity.fieldset.vo.TypeTreeVO;
import org.apache.commons.collections.CollectionUtils;

import java.util.Collections;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @Author weaver_cl
 * @Description:
 * @Date 2022/6/14
 * @Version V1.0
 **/
public class ExtendGroupBO {

    public static List<TypeTreeVO> buildTypeTree(List<ExtendGroupPO> extendGroupPOS) {

        if(CollectionUtils.isEmpty(extendGroupPOS)){
            return Collections.emptyList();
        }

        List<TypeTreeVO> typeTreeVOS = extendGroupPOS.stream().map(e ->
                TypeTreeVO.builder()
                        .addChild(e.getId() >= 0)
                        .canClick(true)
                        .domid(String.valueOf(e.getId()))
                        .hasGroup(isHasGroup(e.getId()))
                        .haschild(getHasChild(e.getId()))
                        .isShow(e.getIsShow())
                        .key(e.getId())
                        .name(e.getGroupName())
                        .viewAttr(e.getId() <= 0 ? 1 : 2)
                        .pid(e.getPid())
                        .build()).collect(Collectors.toList());

        //获取非一级
        Map<Long, List<TypeTreeVO>> collects = typeTreeVOS.stream().filter(item -> item.getPid() != null).collect(Collectors.groupingBy(TypeTreeVO ::getPid));

        return typeTreeVOS.stream().peek(e -> e.setSubs(collects.get(e.getKey()))).filter(item -> item.getPid() == null).collect(Collectors.toList());

    }



    private static boolean getHasChild(Long id) {
        return true;
    }


    private static boolean isHasGroup(Long id) {
        return true;
    }
}
